# coding: utf-8

"""
    Layered Insight Scan

    Layered Insight Scan performs static vulnerability analysis, license and package compliance.  You can find out more about Scan at http://layeredinsight.com.

    OpenAPI spec version: 0.9.6
    Contact: help@layeredinsight.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class EcrCredentials(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'aws_access_id': 'str',
        'aws_secret_id': 'str'
    }

    attribute_map = {
        'aws_access_id': 'AWSAccessID',
        'aws_secret_id': 'AWSSecretID'
    }

    def __init__(self, aws_access_id=None, aws_secret_id=None):
        """
        EcrCredentials - a model defined in Swagger
        """

        self._aws_access_id = None
        self._aws_secret_id = None

        if aws_access_id is not None:
          self.aws_access_id = aws_access_id
        if aws_secret_id is not None:
          self.aws_secret_id = aws_secret_id

    @property
    def aws_access_id(self):
        """
        Gets the aws_access_id of this EcrCredentials.
        AWS Access ID for ECR

        :return: The aws_access_id of this EcrCredentials.
        :rtype: str
        """
        return self._aws_access_id

    @aws_access_id.setter
    def aws_access_id(self, aws_access_id):
        """
        Sets the aws_access_id of this EcrCredentials.
        AWS Access ID for ECR

        :param aws_access_id: The aws_access_id of this EcrCredentials.
        :type: str
        """

        self._aws_access_id = aws_access_id

    @property
    def aws_secret_id(self):
        """
        Gets the aws_secret_id of this EcrCredentials.
        AWS Secret ID for ECR

        :return: The aws_secret_id of this EcrCredentials.
        :rtype: str
        """
        return self._aws_secret_id

    @aws_secret_id.setter
    def aws_secret_id(self, aws_secret_id):
        """
        Sets the aws_secret_id of this EcrCredentials.
        AWS Secret ID for ECR

        :param aws_secret_id: The aws_secret_id of this EcrCredentials.
        :type: str
        """

        self._aws_secret_id = aws_secret_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, EcrCredentials):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
