# coding: utf-8

"""
    Layered Insight Scan

    Layered Insight Scan performs static vulnerability analysis, license and package compliance.  You can find out more about Scan at http://layeredinsight.com.

    OpenAPI spec version: 0.9.6
    Contact: help@layeredinsight.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Registry(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'type': 'str',
        'url': 'str',
        'username': 'str',
        'password': 'str',
        'tls_verify': 'bool',
        'insecure_registry': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'type': 'type',
        'url': 'URL',
        'username': 'username',
        'password': 'password',
        'tls_verify': 'TlsVerify',
        'insecure_registry': 'InsecureRegistry'
    }

    def __init__(self, id=None, name=None, type=None, url=None, username=None, password=None, tls_verify=True, insecure_registry=False):
        """
        Registry - a model defined in Swagger
        """

        self._id = None
        self._name = None
        self._type = None
        self._url = None
        self._username = None
        self._password = None
        self._tls_verify = None
        self._insecure_registry = None

        if id is not None:
          self.id = id
        if name is not None:
          self.name = name
        if type is not None:
          self.type = type
        if url is not None:
          self.url = url
        if username is not None:
          self.username = username
        if password is not None:
          self.password = password
        if tls_verify is not None:
          self.tls_verify = tls_verify
        if insecure_registry is not None:
          self.insecure_registry = insecure_registry

    @property
    def id(self):
        """
        Gets the id of this Registry.
        Server-generated hex identifier of registry within Scan.

        :return: The id of this Registry.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Registry.
        Server-generated hex identifier of registry within Scan.

        :param id: The id of this Registry.
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """
        Gets the name of this Registry.
        Human-readable name of registry

        :return: The name of this Registry.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Registry.
        Human-readable name of registry

        :param name: The name of this Registry.
        :type: str
        """

        self._name = name

    @property
    def type(self):
        """
        Gets the type of this Registry.
        Registry type - can be one of dtr, docker.io, quay.io

        :return: The type of this Registry.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this Registry.
        Registry type - can be one of dtr, docker.io, quay.io

        :param type: The type of this Registry.
        :type: str
        """

        self._type = type

    @property
    def url(self):
        """
        Gets the url of this Registry.
        URL of registry

        :return: The url of this Registry.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """
        Sets the url of this Registry.
        URL of registry

        :param url: The url of this Registry.
        :type: str
        """

        self._url = url

    @property
    def username(self):
        """
        Gets the username of this Registry.
        Username to authenticate to registry with

        :return: The username of this Registry.
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """
        Sets the username of this Registry.
        Username to authenticate to registry with

        :param username: The username of this Registry.
        :type: str
        """

        self._username = username

    @property
    def password(self):
        """
        Gets the password of this Registry.
        Password to authenticate to registry with

        :return: The password of this Registry.
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """
        Sets the password of this Registry.
        Password to authenticate to registry with

        :param password: The password of this Registry.
        :type: str
        """

        self._password = password

    @property
    def tls_verify(self):
        """
        Gets the tls_verify of this Registry.
        Enables server certificate verification

        :return: The tls_verify of this Registry.
        :rtype: bool
        """
        return self._tls_verify

    @tls_verify.setter
    def tls_verify(self, tls_verify):
        """
        Sets the tls_verify of this Registry.
        Enables server certificate verification

        :param tls_verify: The tls_verify of this Registry.
        :type: bool
        """

        self._tls_verify = tls_verify

    @property
    def insecure_registry(self):
        """
        Gets the insecure_registry of this Registry.
        Allows HTTP protocol requests when set insecure

        :return: The insecure_registry of this Registry.
        :rtype: bool
        """
        return self._insecure_registry

    @insecure_registry.setter
    def insecure_registry(self, insecure_registry):
        """
        Sets the insecure_registry of this Registry.
        Allows HTTP protocol requests when set insecure

        :param insecure_registry: The insecure_registry of this Registry.
        :type: bool
        """

        self._insecure_registry = insecure_registry

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Registry):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
